// Zasobnik.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <conio.h>

// zvlastnim definovanim struktury Polozka se nemusime zabyvat,
// kompilator to zvlada. Toto bylo potreba delat v drivejsich verzich.
// typedef struct Polozka;

// struktura reprezentujici jednu "krabicku" v spojovem seznamu.
struct Polozka
{
	int cislo; // sem se bude ukladat hodnota, co dava funkce push() a vraci pop()
	Polozka * next; // ukazatel na nasledujici prvek v seznamu
};

// ukazatel na prvni prvek
Polozka * vrchol = NULL; // ze zacatku neukazuje nikam, tak mu dame NULL

// vlozi prvek i na zacatek seznamu
void push(int i)
{
	// potrebujeme novou polozku. Musime si tedy rici o pamet, ktera bude
	// slouzit k jejimu ulozeni.
	Polozka * nova = (Polozka *) malloc(sizeof(Polozka));

	// do teto nove polozky ulozime cislo, ktere jsme dostali
	(*nova).cislo = i;
	// vrchol ukazoval na prvni polozku, ta se ale posunula na druhe misto
	// a nase nova bude prvni. Tedy z nasi nove si budeme ukazovat tam, kam
	// dosud ukazoval vrchol, tj. na dalsi polozku
	(*nova).next = vrchol;

	// a prvni (na vrcholu) je ted nase nova
	vrchol = nova;

	// vsimete si, ze pokud jsme prave vlozili prvni polozku, tak jeji odkaz
	// next je roven NULL, protoze se do ni ulozilo to, kam ukazoval vrchol
	// a ten je pri prazdnem seznamu roven NULL.
	// vkladani prvni polozky tedy neni treba delat nejak specialne.
}

// Odebere vrchni prvek a vrati hodnotu, kterou ma v sobe ulozenou.
// Pokud v zasobniku nic neni, vraci -1.
int pop()
{
	// mame neco v zasobniku?
	if (vrchol == NULL)
		return -1; // nemame, vrat -1

	// ted uz vime, ze v zasobniku neco je.

	// zapamatujeme si ukazatel na druhou polozku, ten prijde pak do
	// promenne vrchol. Musime si ho pamatovat zvlast proto, ze vrchol
	// ted nemuzeme prepsat, ztratili bychom ukazatel na prvni prvek, ktery
	// musime uvolnit
	Polozka * druha = (*vrchol).next;
	// ze stejneho duvodu si zapamatujeme ve zvlastni promenne cislo, jez
	// prvni polozka obsahuje
	int cislo_na_vraceni = (*vrchol).cislo;

	// uvolnime prvni polozku (na tu ukazuje vrchol)
	free(vrchol);

	// na vrcholu ted bude druha polozka
	vrchol = druha;

	// a vratime cislo, ktere bylo v prvni (ted jiz odstranene) polozce
	return cislo_na_vraceni;
}

int main()
{
	// vkladame do zasobniku ruzna cisla a opet vyjimame a vypisujeme

	puts("vkladam 4");
	push(4);

	puts("vkladam 2");
	push(2);
	
	printf("odebral jsem %i\n", pop());

	puts("vkladam 49");
	push(49);

	puts("vkladam 34");
	push(34);

	printf("odebral jsem %i\n", pop());

	printf("odebral jsem %i\n", pop());

	puts("vkladam 15");
	push(15);

	// a vycisteni na zaver - pokud v zasobniku neco zustalo (jako ze
	// ted zustalo), tak to vsechno odstranime. Nez program skonci,
	// nemel by mit naalokovanou zadnou pamet, cili na vsechno, na co kdy
	// zavolal malloc() by mel zavolat take free()
	// toto uvolneni nam zajisti funkce pop(), kterou budeme volat tak dlouho,
	// dokud v zasobniku neco bude

	int a;
	do
	{
		a = pop();
		if (a != -1)
			// a neni -1, byl to platny prvek
			printf("nakonec odebiram %i\n", a);
		else
			// a == -1 coz indikuje, ze uz v zasobniku nic neni
			puts("zasobnik je prazdny");
	}
	while (a != -1); // kdyz v zasobniku nic neni, muzeme skoncit

	getch();
	return 0;
}
